Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImplicitSelectionLoop Class Reference

`#include <vtkImplicitSelectionLoop.h>`

Inheritance diagram for vtkImplicitSelectionLoop:

[legend]
Collaboration diagram for vtkImplicitSelectionLoop:

[legend]
List of all members.

## Detailed Description

implicit function for a selection loop

Date:
  2002/10/04 20:43:44

Revision:
  1.20

vtkImplicitSelectionLoop computes the implicit function value and function gradient for a irregular, cylinder-like object whose cross section is defined by a set of points forming a loop. The loop need not be convex nor its points coplanar. However, the loop must be non-self-intersecting when projected onto the plane defined by the accumulated cross product around the loop (i.e., the axis of the loop). (Alternatively, you can specify the normal to use.)

The following procedure is used to compute the implicit function value for a point x. Each point of the loop is first projected onto the plane defined by the loop normal. This forms a polygon. Then, to evaluate the implicit function value, inside/outside tests are used to determine if x is inside the polygon, and the distance to the loop boundary is computed (negative values are inside the loop).

One example application of this implicit function class is to draw a loop on the surface of a mesh, and use the loop to clip or extract cells from within the loop. Remember, the selection loop is "infinite" in length, you can use a plane (in boolean combination) to cap the extent of the selection loop. Another trick is to use a connectivity filter to extract the closest region to a given point (i.e., one of the points used to define the selection loop).

See also:
  vtkImplicitFunction vtkImplicitBoolean vtkExtractGeometry vtkClipPolyData vtkConnectivityFilter vtkPolyDataConnectivityFilter

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (82%)
  - Cedilnik, Andy (5%)

CVS logs (CVSweb):
  - .`h` (`/Filtering/vtkImplicitSelectionLoop.h)`
  - .`cxx` (`/Filtering/vtkImplicitSelectionLoop.cxx)`

Tests:
  vtkImplicitSelectionLoop (Tests)

Definition at line 73 of file vtkImplicitSelectionLoop.h.

## Public Types
typedef vtkImplicitFunction | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | EvaluateGradient (float x[3], float n[3])
unsigned long | GetMTime ()
float | EvaluateFunction (float x[3])
float | EvaluateFunction (float x, float y, float z)
virtual void | SetLoop (vtkPoints *)
virtual vtkPoints * | GetLoop ()
virtual void | SetAutomaticNormalGeneration (int)
virtual int | GetAutomaticNormalGeneration ()
virtual void | AutomaticNormalGenerationOn ()
virtual void | AutomaticNormalGenerationOff ()
virtual void | SetNormal (float, float, float)
virtual void | SetNormal (float[3])
virtual float * | GetNormal ()
virtual void | GetNormal (float data[3])
## Static Public Methods
int | IsTypeOf (const char *type)
vtkImplicitSelectionLoop * | SafeDownCast (vtkObject *o)
vtkImplicitSelectionLoop * | New ()
## Protected Methods
| vtkImplicitSelectionLoop ()
| ~vtkImplicitSelectionLoop ()
## Protected Attributes
vtkPoints * | Loop
float | Normal [3]
int | AutomaticNormalGeneration

## Member Typedef Documentation

typedef vtkImplicitFunction vtkImplicitSelectionLoop::Superclass

| Reimplemented from vtkImplicitFunction. Definition at line 76 of file vtkImplicitSelectionLoop.h.

## Constructor & Destructor Documentation

vtkImplicitSelectionLoop::vtkImplicitSelectionLoop | ( |  | ) | `[protected]`

vtkImplicitSelectionLoop::~vtkImplicitSelectionLoop | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkImplicitSelectionLoop::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkImplicitFunction.

int vtkImplicitSelectionLoop::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImplicitFunction.

virtual int vtkImplicitSelectionLoop::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImplicitFunction.

vtkImplicitSelectionLoop* vtkImplicitSelectionLoop::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkImplicitFunction.

void vtkImplicitSelectionLoop::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkImplicitFunction.

vtkImplicitSelectionLoop* vtkImplicitSelectionLoop::New | ( |  | ) | `[static]`

| Instantiate object with no initial loop. Reimplemented from vtkObject.

float vtkImplicitSelectionLoop::EvaluateFunction | ( | float | x[3] | ) | `[virtual]`

| Evaluate selection loop returning a signed distance. Implements vtkImplicitFunction.

float vtkImplicitSelectionLoop::EvaluateFunction | ( | float | x,
|  | float | y,
|  | float | z
| ) | `[inline]`

| Evaluate selection loop returning a signed distance. Reimplemented from vtkImplicitFunction. Definition at line 85 of file vtkImplicitSelectionLoop.h. References vtkImplicitFunction::EvaluateFunction().

void vtkImplicitSelectionLoop::EvaluateGradient | ( | float | x[3],
|  | float | n[3]
| ) | `[virtual]`

| Evaluate selection loop returning the gradient. Implements vtkImplicitFunction.

virtual void vtkImplicitSelectionLoop::SetLoop | ( | vtkPoints * |  | ) | `[virtual]`

| Set/Get the array of point coordinates defining the loop. There must be at least three points used to define a loop.

virtual vtkPoints* vtkImplicitSelectionLoop::GetLoop | ( |  | ) | `[virtual]`

| Set/Get the array of point coordinates defining the loop. There must be at least three points used to define a loop.

virtual void vtkImplicitSelectionLoop::SetAutomaticNormalGeneration | ( | int |  | ) | `[virtual]`

| Turn on/off automatic normal generation. By default, the normal is computed from the accumulated cross product of the edges. You can also specify the normal to use.

virtual int vtkImplicitSelectionLoop::GetAutomaticNormalGeneration | ( |  | ) | `[virtual]`

| Turn on/off automatic normal generation. By default, the normal is computed from the accumulated cross product of the edges. You can also specify the normal to use.

virtual void vtkImplicitSelectionLoop::AutomaticNormalGenerationOn | ( |  | ) | `[virtual]`

| Turn on/off automatic normal generation. By default, the normal is computed from the accumulated cross product of the edges. You can also specify the normal to use.

virtual void vtkImplicitSelectionLoop::AutomaticNormalGenerationOff | ( |  | ) | `[virtual]`

| Turn on/off automatic normal generation. By default, the normal is computed from the accumulated cross product of the edges. You can also specify the normal to use.

virtual void vtkImplicitSelectionLoop::SetNormal | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set / get the normal used to determine what is inside and what is outside.

virtual void vtkImplicitSelectionLoop::SetNormal | ( | float | [3] | ) | `[virtual]`

| Set / get the normal used to determine what is inside and what is outside.

virtual float* vtkImplicitSelectionLoop::GetNormal | ( |  | ) | `[virtual]`

| Set / get the normal used to determine what is inside and what is outside.

virtual void vtkImplicitSelectionLoop::GetNormal | ( | float | data[3] | ) | `[virtual]`

| Set / get the normal used to determine what is inside and what is outside.

unsigned long vtkImplicitSelectionLoop::GetMTime | ( |  | ) | `[virtual]`

| Overload GetMTime() because we depend on the Loop Reimplemented from vtkImplicitFunction.

## Member Data Documentation

vtkPoints* vtkImplicitSelectionLoop::Loop`[protected]`

| Definition at line 122 of file vtkImplicitSelectionLoop.h.

float vtkImplicitSelectionLoop::Normal[3]`[protected]`

| Definition at line 123 of file vtkImplicitSelectionLoop.h.

int vtkImplicitSelectionLoop::AutomaticNormalGeneration`[protected]`

| Definition at line 124 of file vtkImplicitSelectionLoop.h.

The documentation for this class was generated from the following file:

- Filtering/vtkImplicitSelectionLoop.h